"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClientAppController = void 0;
const tslib_1 = require("tslib");
// api-key.controller.ts
const core_1 = require("@loopback/core");
const repository_1 = require("@loopback/repository");
const rest_1 = require("@loopback/rest");
const core_2 = require("@sourceloop/core");
const loopback4_authentication_1 = require("loopback4-authentication");
const loopback4_authorization_1 = require("loopback4-authorization");
const models_1 = require("../../../models");
const utility_service_1 = require("../../../services/utility.service");
const models_2 = require("../models");
const repositories_1 = require("../repositories");
let ClientAppController = class ClientAppController {
    constructor(utilityService, clientAppRepo) {
        this.utilityService = utilityService;
        this.clientAppRepo = clientAppRepo;
    }
    async generateClientApp(clientApp) {
        const { apiKey, apiSecret } = this.utilityService.generateApiKeyAndSecret(clientApp);
        return this.clientAppRepo.create({
            apiKey,
            apiSecret,
            name: clientApp.clientName,
        });
    }
};
exports.ClientAppController = ClientAppController;
tslib_1.__decorate([
    (0, loopback4_authentication_1.authenticate)("bearer" /* STRATEGY.BEARER */),
    (0, loopback4_authorization_1.authorize)({ permissions: ["16001" /* TaskPermssionKey.CreateApiKey */] }),
    (0, rest_1.post)('/client-app', {
        security: core_2.OPERATION_SECURITY_SPEC,
        responses: {
            [200 /* STATUS_CODE.OK */]: {
                description: 'Generated Client Application',
                content: {
                    [core_2.CONTENT_TYPE.JSON]: {
                        schema: (0, rest_1.getModelSchemaRef)(models_2.ClientApp, { exclude: ['id'] }),
                    },
                },
            },
        },
    }),
    tslib_1.__param(0, (0, rest_1.requestBody)({
        content: {
            [core_2.CONTENT_TYPE.JSON]: {
                schema: (0, rest_1.getModelSchemaRef)(models_1.ClientAppDTO, {
                    title: 'ClientApp',
                }),
            },
        },
    })),
    tslib_1.__metadata("design:type", Function),
    tslib_1.__metadata("design:paramtypes", [models_1.ClientAppDTO]),
    tslib_1.__metadata("design:returntype", Promise)
], ClientAppController.prototype, "generateClientApp", null);
exports.ClientAppController = ClientAppController = tslib_1.__decorate([
    (0, core_1.injectable)(),
    tslib_1.__param(0, (0, core_1.service)(utility_service_1.UtilityService)),
    tslib_1.__param(1, (0, repository_1.repository)(repositories_1.ClientAppRepository)),
    tslib_1.__metadata("design:paramtypes", [utility_service_1.UtilityService,
        repositories_1.ClientAppRepository])
], ClientAppController);
//# sourceMappingURL=client-app.controller.js.map