"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KafkaEventAdapter = void 0;
const types_1 = require("../../types");
class KafkaEventAdapter {
    adaptTo(event) {
        var _a, _b;
        const key = event.topic;
        const timestamp = Number(event.message.timestamp);
        const source = types_1.Source.Kafka;
        const payload = JSON.parse((_b = (_a = event.message.value) === null || _a === void 0 ? void 0 : _a.toString('utf8')) !== null && _b !== void 0 ? _b : '{}');
        return Promise.resolve({ key, timestamp, source, payload });
    }
    async adaptFrom(event) {
        return event;
    }
}
exports.KafkaEventAdapter = KafkaEventAdapter;
//# sourceMappingURL=kafka-adapter.service.js.map