import { Count, Filter, FilterExcludingWhere, Where } from '@loopback/repository';
import { WorkflowRepository } from '@sourceloop/bpmn-service';
import { Event, EventWorkflow } from '../models';
import { EventRepository, EventWorkflowRepository } from '../repositories';
export declare class EventController {
    private readonly eventWorkflowMapping;
    private readonly eventRepository;
    private readonly workflowRepository;
    constructor(eventWorkflowMapping: EventWorkflowRepository, eventRepository: EventRepository, workflowRepository: WorkflowRepository);
    find(filter?: Filter<Event>): Promise<Event[]>;
    findById(id: string, filter?: FilterExcludingWhere<Event>): Promise<Event>;
    count(where?: Where<Event>): Promise<Count>;
    mapEventToWorkflow(eventWorkflowMapping: Omit<EventWorkflow, 'id'>): Promise<void>;
}
