import { Count, Filter, FilterExcludingWhere, Where } from '@loopback/repository';
import { IUserTaskService } from '../interfaces';
import { UserTask } from '../models';
import { TaskRepository, UserTaskRepository } from '../repositories';
export declare class TaskUserTaskController {
    private readonly userTaskService;
    private readonly taskRepo;
    private readonly userTaskRepo;
    constructor(userTaskService: IUserTaskService, taskRepo: TaskRepository, userTaskRepo: UserTaskRepository);
    completeTask(id: string, userTaskId: string): Promise<void>;
    find(taskId: string, filter?: Filter<UserTask>): Promise<UserTask[]>;
    findById(taskId: string, userTaskId: string, filter?: FilterExcludingWhere<UserTask>): Promise<UserTask>;
    count(taskId: string, where?: Where<UserTask>): Promise<Count>;
    deleteById(id: string): Promise<void>;
    delete(where?: Where<UserTask>): Promise<void>;
}
