"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CommandObserver = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const bpmn_service_1 = require("@sourceloop/bpmn-service");
const core_2 = require("@sourceloop/core");
const keys_1 = require("../keys");
let CommandObserver = class CommandObserver {
    constructor(logger, commandsCtors, ctx, workerFn) {
        this.logger = logger;
        this.commandsCtors = commandsCtors;
        this.ctx = ctx;
        this.workerFn = workerFn;
    }
    async start() {
        for (const cmdCtor of this.commandsCtors) {
            const command = new cmdCtor(this.ctx);
            this.logger.debug(`Registering command ${command.topic}`);
            await this.workerFn({
                topic: command.topic,
                command: new bpmn_service_1.BPMTask(command),
                running: false,
            });
        }
        this.logger.debug('Commands registered');
    }
    async stop() {
        // not required
    }
};
exports.CommandObserver = CommandObserver;
exports.CommandObserver = CommandObserver = tslib_1.__decorate([
    (0, core_1.lifeCycleObserver)(),
    tslib_1.__param(0, (0, core_1.inject)(core_2.LOGGER.LOGGER_INJECT)),
    tslib_1.__param(1, (0, core_1.inject)(keys_1.TaskServiceBindings.COMMANDS)),
    tslib_1.__param(2, core_1.inject.context()),
    tslib_1.__param(3, (0, core_1.inject)(bpmn_service_1.WorkflowServiceBindings.WorkerImplementationFunction)),
    tslib_1.__metadata("design:paramtypes", [Object, Array, core_1.Context, Function])
], CommandObserver);
//# sourceMappingURL=command.observer.js.map