"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TaskRepository = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@loopback/core");
const repository_1 = require("@loopback/repository");
const sequelize_1 = require("@loopback/sequelize");
const sequelize_2 = require("@sourceloop/core/sequelize");
const loopback4_authentication_1 = require("loopback4-authentication");
const types_1 = require("../../types");
let TaskRepository = class TaskRepository extends sequelize_2.SequelizeUserModifyCrudRepository {
    constructor(dataSource, userTaskRepo, userGetter, task) {
        super(task, dataSource, userGetter);
        this.userGetter = userGetter;
        this.task = task;
        this.userTasks = this.createHasManyRepositoryFactoryFor('userTasks', userTaskRepo);
    }
};
exports.TaskRepository = TaskRepository;
exports.TaskRepository = TaskRepository = tslib_1.__decorate([
    tslib_1.__param(0, (0, core_1.inject)(`datasources.${types_1.TaskDbSourceName}`)),
    tslib_1.__param(1, repository_1.repository.getter('UserTaskRepository')),
    tslib_1.__param(2, core_1.inject.getter(loopback4_authentication_1.AuthenticationBindings.CURRENT_USER)),
    tslib_1.__param(3, (0, core_1.inject)('models.Task')),
    tslib_1.__metadata("design:paramtypes", [sequelize_1.SequelizeDataSource, Function, Function, Object])
], TaskRepository);
//# sourceMappingURL=task.repository.js.map